<template>
    <Select2
        v-model="selected"
        :options="options"
        :settings="settings"
        @select="onSelect"
    />
</template>

<script>
import { reactive, ref } from "vue";
import Select2 from "vue3-select2-component";

export default {
    components: {
        Select2
    },
    props: {
        value: [String, Number, Array],
        options: {
            type: Array,
            required: true
        },
        isMultiple: {
            type: Boolean,
            default: false
        },
        isNotCloseOnSelect: {
            type: Boolean,
            default: false
        }
    },
    setup(props, context) {
        const selected = ref(props.value || []);
        const settings = reactive({
            width: "100%",
            multiple: props.isMultiple,
            closeOnSelect: !props.isNotCloseOnSelect
        });

        function onSelect() {
            context.emit("update:value", selected.value);
        }

        return {
            selected,
            settings,
            onSelect
        };
    }
};
</script>

<style lang="scss">
.select2-container--default .select2-selection--multiple {
    @apply border-gray-200;
}
.select2-container--default.select2-container--focus
    .select2-selection--multiple {
    @apply border-main-color;
}
.select2-container--default
    .select2-selection--multiple
    .select2-selection__choice {
    @apply bg-main-color;
    @apply text-white;
    @apply border-main-color;
    font-size: 13px;
}
.select2-container--default
    .select2-selection--multiple
    .select2-selection__choice__remove {
    margin-right: 5px;
    @apply text-white;
    &:hover {
        @apply text-white;
    }
}
.select2-container--default
    .select2-results__option--highlighted[aria-selected] {
    background-color: rgba($color: #7367f0, $alpha: 0.1);
    @apply text-main-color;
}
.select2-container--default .select2-results__option[aria-selected="true"] {
    @apply bg-main-color;
    @apply text-white;
}
</style>
